require "Window"
 
local GroupRealLevel = {} 
 
function GroupRealLevel:new(o)
    o = o or {}
    setmetatable(o, self)
    self.__index = self 

    return o
end

function GroupRealLevel:Init()
	local bHasConfigureFunction = false
	local strConfigureButtonText = ""
	local tDependencies = {
		-- "GroupFrame",
	}
	
    Apollo.RegisterAddon(self, bHasConfigureFunction, strConfigureButtonText, tDependencies)

	--Apollo.RegisterSlashCommand("grltest", "OnGrlTestCmd", self)

end
 
function GroupRealLevel:OnLoad()
	Apollo.GetPackage("Gemini:Hook-1.0").tPackage:Embed(self)
	
	-- hook into
	self:RawHook(Apollo.GetAddon("GroupDisplay"), "DrawMemberPortrait")
end


function GroupRealLevel:DrawMemberPortrait(luaCaller, tPortrait, tMemberInfo)
	
	if(tMemberInfo.nLevel ~= tMemberInfo.nEffectiveLevel ) then
		tMemberInfo.strCharacterName = tMemberInfo.strCharacterName .. " (" .. tMemberInfo.nLevel .. ")"
	end

	-- add item level	
	local unitMember = GroupLib.GetUnitForGroupMember(tPortrait.idx)
	tMemberInfo.strCharacterName = tMemberInfo.strCharacterName .. " (ilvl " .. self:round(unitMember:GetEffectiveItemLevel(),0).. ")"
	
	-- call original
	self.hooks[Apollo.GetAddon("GroupDisplay")].DrawMemberPortrait(luaCaller, tPortrait, tMemberInfo)
end

function GroupRealLevel:round(num, idp)
  local mult = 10^(idp or 0)
  return math.floor(num * mult + 0.5) / mult
end

local GroupRealLevelInst = GroupRealLevel:new()
GroupRealLevelInst:Init()
